﻿using System;
using System.IO;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;


namespace Sudoku
{
    public partial class Form1 : Form
    {
        PuzzleModule.Puzzle puzzle;
        InferenceModule.Inference inference;

        public Form1()
        {
            InitializeComponent();
            puzzle = new PuzzleModule.Puzzle();
            puzzle.Initialize();

            inference = new InferenceModule.Inference();
        }

        //*************************************************************
        // Function:Display()
        //***************************************************************
	    public
	    void Display ()
        {
            puzzle.grid.ElementAt(0).ElementAt(0);

            // Row #0
            TB0.Text = puzzle.grid.ElementAt(0).ElementAt(0).ToString();
            TB1.Text = puzzle.grid.ElementAt(0).ElementAt(1).ToString();
            TB2.Text = puzzle.grid.ElementAt(0).ElementAt(2).ToString();
            TB3.Text = puzzle.grid.ElementAt(0).ElementAt(3).ToString();
            TB4.Text = puzzle.grid.ElementAt(0).ElementAt(4).ToString();
            TB5.Text = puzzle.grid.ElementAt(0).ElementAt(5).ToString();
            TB6.Text = puzzle.grid.ElementAt(0).ElementAt(6).ToString();
            TB7.Text = puzzle.grid.ElementAt(0).ElementAt(7).ToString();
            TB8.Text = puzzle.grid.ElementAt(0).ElementAt(8).ToString();

            // Row #1
            TB10.Text = puzzle.grid.ElementAt(1).ElementAt(0).ToString();
            TB11.Text = puzzle.grid.ElementAt(1).ElementAt(1).ToString();
            TB12.Text = puzzle.grid.ElementAt(1).ElementAt(2).ToString();
            TB13.Text = puzzle.grid.ElementAt(1).ElementAt(3).ToString();
            TB14.Text = puzzle.grid.ElementAt(1).ElementAt(4).ToString();
            TB15.Text = puzzle.grid.ElementAt(1).ElementAt(5).ToString();
            TB16.Text = puzzle.grid.ElementAt(1).ElementAt(6).ToString();
            TB17.Text = puzzle.grid.ElementAt(1).ElementAt(7).ToString();
            TB18.Text = puzzle.grid.ElementAt(1).ElementAt(8).ToString();

            // Row #2
            TB20.Text = puzzle.grid.ElementAt(2).ElementAt(0).ToString();
            TB21.Text = puzzle.grid.ElementAt(2).ElementAt(1).ToString();
            TB22.Text = puzzle.grid.ElementAt(2).ElementAt(2).ToString();
            TB23.Text = puzzle.grid.ElementAt(2).ElementAt(3).ToString();
            TB24.Text = puzzle.grid.ElementAt(2).ElementAt(4).ToString();
            TB25.Text = puzzle.grid.ElementAt(2).ElementAt(5).ToString();
            TB26.Text = puzzle.grid.ElementAt(2).ElementAt(6).ToString();
            TB27.Text = puzzle.grid.ElementAt(2).ElementAt(7).ToString();
            TB28.Text = puzzle.grid.ElementAt(2).ElementAt(8).ToString();

            // Row #3
            TB30.Text = puzzle.grid.ElementAt(3).ElementAt(0).ToString();
            TB31.Text = puzzle.grid.ElementAt(3).ElementAt(1).ToString();
            TB32.Text = puzzle.grid.ElementAt(3).ElementAt(2).ToString();
            TB33.Text = puzzle.grid.ElementAt(3).ElementAt(3).ToString();
            TB34.Text = puzzle.grid.ElementAt(3).ElementAt(4).ToString();
            TB35.Text = puzzle.grid.ElementAt(3).ElementAt(5).ToString();
            TB36.Text = puzzle.grid.ElementAt(3).ElementAt(6).ToString();
            TB37.Text = puzzle.grid.ElementAt(3).ElementAt(7).ToString();
            TB38.Text = puzzle.grid.ElementAt(3).ElementAt(8).ToString();

            // Row #4
            TB40.Text = puzzle.grid.ElementAt(4).ElementAt(0).ToString();
            TB41.Text = puzzle.grid.ElementAt(4).ElementAt(1).ToString();
            TB42.Text = puzzle.grid.ElementAt(4).ElementAt(2).ToString();
            TB43.Text = puzzle.grid.ElementAt(4).ElementAt(3).ToString();
            TB44.Text = puzzle.grid.ElementAt(4).ElementAt(4).ToString();
            TB45.Text = puzzle.grid.ElementAt(4).ElementAt(5).ToString();
            TB46.Text = puzzle.grid.ElementAt(4).ElementAt(6).ToString();
            TB47.Text = puzzle.grid.ElementAt(4).ElementAt(7).ToString();
            TB48.Text = puzzle.grid.ElementAt(4).ElementAt(8).ToString();

            // Row #5
            TB50.Text = puzzle.grid.ElementAt(5).ElementAt(0).ToString();
            TB51.Text = puzzle.grid.ElementAt(5).ElementAt(1).ToString();
            TB52.Text = puzzle.grid.ElementAt(5).ElementAt(2).ToString();
            TB53.Text = puzzle.grid.ElementAt(5).ElementAt(3).ToString();
            TB54.Text = puzzle.grid.ElementAt(5).ElementAt(4).ToString();
            TB55.Text = puzzle.grid.ElementAt(5).ElementAt(5).ToString();
            TB56.Text = puzzle.grid.ElementAt(5).ElementAt(6).ToString();
            TB57.Text = puzzle.grid.ElementAt(5).ElementAt(7).ToString();
            TB58.Text = puzzle.grid.ElementAt(5).ElementAt(8).ToString();

            // Row #6
            TB60.Text = puzzle.grid.ElementAt(6).ElementAt(0).ToString();
            TB61.Text = puzzle.grid.ElementAt(6).ElementAt(1).ToString();
            TB62.Text = puzzle.grid.ElementAt(6).ElementAt(2).ToString();
            TB63.Text = puzzle.grid.ElementAt(6).ElementAt(3).ToString();
            TB64.Text = puzzle.grid.ElementAt(6).ElementAt(4).ToString();
            TB65.Text = puzzle.grid.ElementAt(6).ElementAt(5).ToString();
            TB66.Text = puzzle.grid.ElementAt(6).ElementAt(6).ToString();
            TB67.Text = puzzle.grid.ElementAt(6).ElementAt(7).ToString();
            TB68.Text = puzzle.grid.ElementAt(6).ElementAt(8).ToString();

            // Row #7
            TB70.Text = puzzle.grid.ElementAt(7).ElementAt(0).ToString();
            TB71.Text = puzzle.grid.ElementAt(7).ElementAt(1).ToString();
            TB72.Text = puzzle.grid.ElementAt(7).ElementAt(2).ToString();
            TB73.Text = puzzle.grid.ElementAt(7).ElementAt(3).ToString();
            TB74.Text = puzzle.grid.ElementAt(7).ElementAt(4).ToString();
            TB75.Text = puzzle.grid.ElementAt(7).ElementAt(5).ToString();
            TB76.Text = puzzle.grid.ElementAt(7).ElementAt(6).ToString();
            TB77.Text = puzzle.grid.ElementAt(7).ElementAt(7).ToString();
            TB78.Text = puzzle.grid.ElementAt(7).ElementAt(8).ToString();

            // Row #8
            TB80.Text = puzzle.grid.ElementAt(8).ElementAt(0).ToString();
            TB81.Text = puzzle.grid.ElementAt(8).ElementAt(1).ToString();
            TB82.Text = puzzle.grid.ElementAt(8).ElementAt(2).ToString();
            TB83.Text = puzzle.grid.ElementAt(8).ElementAt(3).ToString();
            TB84.Text = puzzle.grid.ElementAt(8).ElementAt(4).ToString();
            TB85.Text = puzzle.grid.ElementAt(8).ElementAt(5).ToString();
            TB86.Text = puzzle.grid.ElementAt(8).ElementAt(6).ToString();
            TB87.Text = puzzle.grid.ElementAt(8).ElementAt(7).ToString();
            TB88.Text = puzzle.grid.ElementAt(8).ElementAt(8).ToString();

            IterativeTB.Text = inference.maxLoopCnt.ToString();
            LogicTB.Text = inference.logicCnt.ToString();
            GuessTB.Text = inference.guessCnt.ToString();
            BackTrackingTB.Text = inference.backTrackCnt.ToString();

            TimeTB.Text = t;
		    return;
	    }

        private void ClearBtn_Click(object sender, EventArgs e)
        {
            TB0.Text = ""; TB1.Text = ""; TB2.Text = ""; TB3.Text = ""; TB4.Text = "";
            TB5.Text = ""; TB6.Text = ""; TB7.Text = ""; TB8.Text = ""; 

            TB10.Text = ""; TB11.Text = ""; TB12.Text = ""; TB13.Text = ""; TB14.Text = "";
            TB15.Text = ""; TB16.Text = ""; TB17.Text = ""; TB18.Text = ""; 

            TB20.Text = ""; TB21.Text = ""; TB22.Text = ""; TB23.Text = ""; TB24.Text = "";
            TB25.Text = ""; TB26.Text = ""; TB27.Text = ""; TB28.Text = ""; 

            TB30.Text = ""; TB31.Text = ""; TB32.Text = ""; TB33.Text = ""; TB34.Text = "";
            TB35.Text = ""; TB36.Text = ""; TB37.Text = ""; TB38.Text = ""; 

            TB40.Text = ""; TB41.Text = ""; TB42.Text = ""; TB43.Text = ""; TB44.Text = "";
            TB45.Text = ""; TB46.Text = ""; TB47.Text = ""; TB48.Text = ""; 

            TB50.Text = ""; TB51.Text = ""; TB52.Text = ""; TB53.Text = ""; TB54.Text = "";
            TB55.Text = ""; TB56.Text = ""; TB57.Text = ""; TB58.Text = ""; 

            TB60.Text = ""; TB61.Text = ""; TB62.Text = ""; TB63.Text = ""; TB64.Text = "";
            TB65.Text = ""; TB66.Text = ""; TB67.Text = ""; TB68.Text = ""; 

            TB70.Text = ""; TB71.Text = ""; TB72.Text = ""; TB73.Text = ""; TB74.Text = "";
            TB75.Text = ""; TB76.Text = ""; TB77.Text = ""; TB78.Text = "";

            TB80.Text = ""; TB81.Text = ""; TB82.Text = ""; TB83.Text = ""; TB84.Text = "";
            TB85.Text = ""; TB86.Text = ""; TB87.Text = ""; TB88.Text = ""; 
        }

       
        private void LoadBtn_Click(object sender, EventArgs e)
        {
            puzzle.Initialize();
                       
            OpenFileDialog openFileDialog = new OpenFileDialog();
		    openFileDialog.InitialDirectory = "C:\\Sudoku\\bin";
		    if (openFileDialog.ShowDialog() == DialogResult.OK)
		    {
                string filename = openFileDialog.FileName;
                StreamReader freader = File.OpenText(filename);
                for (int i = 0; i < 9; i++ ) {
                    puzzle.grid.ElementAt(i).SetValue(freader.Read() - 48, 0);
                    Convert.ToInt32(freader.Read());
                    puzzle.grid.ElementAt(i).SetValue(freader.Read() - 48, 1);
                    Convert.ToInt32(freader.Read());
                    puzzle.grid.ElementAt(i).SetValue(freader.Read() - 48, 2);
                    Convert.ToInt32(freader.Read());
                    puzzle.grid.ElementAt(i).SetValue(freader.Read() - 48, 3);
                    Convert.ToInt32(freader.Read());
                    puzzle.grid.ElementAt(i).SetValue(freader.Read() - 48, 4);
                    Convert.ToInt32(freader.Read());
                    puzzle.grid.ElementAt(i).SetValue(freader.Read() - 48, 5);
                    Convert.ToInt32(freader.Read());
                    puzzle.grid.ElementAt(i).SetValue(freader.Read() - 48, 6);
                    Convert.ToInt32(freader.Read());
                    puzzle.grid.ElementAt(i).SetValue(freader.Read() - 48, 7);
                    Convert.ToInt32(freader.Read());
                    puzzle.grid.ElementAt(i).SetValue(freader.Read() - 48, 8);
                    Convert.ToInt32(freader.Read());
                    Convert.ToInt32(freader.Read());
                }
                
                freader.Close();
            }
		    
            Display();
        }


        private void EnterBtn_Click(object sender, EventArgs e)
        {
            puzzle.Initialize();

            if (TB0.Text.ToString() != "") puzzle.grid.ElementAt(0).SetValue(Convert.ToInt32(TB0.Text.ToString()), 0);
            if (TB1.Text.ToString() != "") puzzle.grid.ElementAt(0).SetValue(Convert.ToInt32(TB1.Text.ToString()), 1);
            if (TB2.Text.ToString() != "") puzzle.grid.ElementAt(0).SetValue(Convert.ToInt32(TB2.Text.ToString()), 2);
            if (TB3.Text.ToString() != "") puzzle.grid.ElementAt(0).SetValue(Convert.ToInt32(TB3.Text.ToString()), 3);
            if (TB4.Text.ToString() != "") puzzle.grid.ElementAt(0).SetValue(Convert.ToInt32(TB4.Text.ToString()), 4);
            if (TB5.Text.ToString() != "") puzzle.grid.ElementAt(0).SetValue(Convert.ToInt32(TB5.Text.ToString()), 5);
            if (TB6.Text.ToString() != "") puzzle.grid.ElementAt(0).SetValue(Convert.ToInt32(TB6.Text.ToString()), 6);
            if (TB7.Text.ToString() != "") puzzle.grid.ElementAt(0).SetValue(Convert.ToInt32(TB7.Text.ToString()), 7);
            if (TB8.Text.ToString() != "") puzzle.grid.ElementAt(0).SetValue(Convert.ToInt32(TB8.Text.ToString()), 8);

            if (TB10.Text.ToString() != "") puzzle.grid.ElementAt(1).SetValue(Convert.ToInt32(TB10.Text.ToString()), 0);
            if (TB11.Text.ToString() != "") puzzle.grid.ElementAt(1).SetValue(Convert.ToInt32(TB11.Text.ToString()), 1);
            if (TB12.Text.ToString() != "") puzzle.grid.ElementAt(1).SetValue(Convert.ToInt32(TB12.Text.ToString()), 2);
            if (TB13.Text.ToString() != "") puzzle.grid.ElementAt(1).SetValue(Convert.ToInt32(TB13.Text.ToString()), 3);
            if (TB14.Text.ToString() != "") puzzle.grid.ElementAt(1).SetValue(Convert.ToInt32(TB14.Text.ToString()), 4);
            if (TB15.Text.ToString() != "") puzzle.grid.ElementAt(1).SetValue(Convert.ToInt32(TB15.Text.ToString()), 5);
            if (TB16.Text.ToString() != "") puzzle.grid.ElementAt(1).SetValue(Convert.ToInt32(TB16.Text.ToString()), 6);
            if (TB17.Text.ToString() != "") puzzle.grid.ElementAt(1).SetValue(Convert.ToInt32(TB17.Text.ToString()), 7);
            if (TB18.Text.ToString() != "") puzzle.grid.ElementAt(1).SetValue(Convert.ToInt32(TB18.Text.ToString()), 8);

            if (TB20.Text.ToString() != "") puzzle.grid.ElementAt(2).SetValue(Convert.ToInt32(TB20.Text.ToString()), 0);
            if (TB21.Text.ToString() != "") puzzle.grid.ElementAt(2).SetValue(Convert.ToInt32(TB21.Text.ToString()), 1);
            if (TB22.Text.ToString() != "") puzzle.grid.ElementAt(2).SetValue(Convert.ToInt32(TB22.Text.ToString()), 2);
            if (TB23.Text.ToString() != "") puzzle.grid.ElementAt(2).SetValue(Convert.ToInt32(TB23.Text.ToString()), 3);
            if (TB24.Text.ToString() != "") puzzle.grid.ElementAt(2).SetValue(Convert.ToInt32(TB24.Text.ToString()), 4);
            if (TB25.Text.ToString() != "") puzzle.grid.ElementAt(2).SetValue(Convert.ToInt32(TB25.Text.ToString()), 5);
            if (TB26.Text.ToString() != "") puzzle.grid.ElementAt(2).SetValue(Convert.ToInt32(TB26.Text.ToString()), 6);
            if (TB27.Text.ToString() != "") puzzle.grid.ElementAt(2).SetValue(Convert.ToInt32(TB27.Text.ToString()), 7);
            if (TB28.Text.ToString() != "") puzzle.grid.ElementAt(2).SetValue(Convert.ToInt32(TB28.Text.ToString()), 8);

            if (TB30.Text.ToString() != "") puzzle.grid.ElementAt(3).SetValue(Convert.ToInt32(TB30.Text.ToString()), 0);
            if (TB31.Text.ToString() != "") puzzle.grid.ElementAt(3).SetValue(Convert.ToInt32(TB31.Text.ToString()), 1);
            if (TB32.Text.ToString() != "") puzzle.grid.ElementAt(3).SetValue(Convert.ToInt32(TB32.Text.ToString()), 2);
            if (TB33.Text.ToString() != "") puzzle.grid.ElementAt(3).SetValue(Convert.ToInt32(TB33.Text.ToString()), 3);
            if (TB34.Text.ToString() != "") puzzle.grid.ElementAt(3).SetValue(Convert.ToInt32(TB34.Text.ToString()), 4);
            if (TB35.Text.ToString() != "") puzzle.grid.ElementAt(3).SetValue(Convert.ToInt32(TB35.Text.ToString()), 5);
            if (TB36.Text.ToString() != "") puzzle.grid.ElementAt(3).SetValue(Convert.ToInt32(TB36.Text.ToString()), 6);
            if (TB37.Text.ToString() != "") puzzle.grid.ElementAt(3).SetValue(Convert.ToInt32(TB37.Text.ToString()), 7);
            if (TB38.Text.ToString() != "") puzzle.grid.ElementAt(3).SetValue(Convert.ToInt32(TB38.Text.ToString()), 8);

            if (TB40.Text.ToString() != "") puzzle.grid.ElementAt(4).SetValue(Convert.ToInt32(TB40.Text.ToString()), 0);
            if (TB41.Text.ToString() != "") puzzle.grid.ElementAt(4).SetValue(Convert.ToInt32(TB41.Text.ToString()), 1);
            if (TB42.Text.ToString() != "") puzzle.grid.ElementAt(4).SetValue(Convert.ToInt32(TB42.Text.ToString()), 2);
            if (TB43.Text.ToString() != "") puzzle.grid.ElementAt(4).SetValue(Convert.ToInt32(TB43.Text.ToString()), 3);
            if (TB44.Text.ToString() != "") puzzle.grid.ElementAt(4).SetValue(Convert.ToInt32(TB44.Text.ToString()), 4);
            if (TB45.Text.ToString() != "") puzzle.grid.ElementAt(4).SetValue(Convert.ToInt32(TB45.Text.ToString()), 5);
            if (TB46.Text.ToString() != "") puzzle.grid.ElementAt(4).SetValue(Convert.ToInt32(TB46.Text.ToString()), 6);
            if (TB47.Text.ToString() != "") puzzle.grid.ElementAt(4).SetValue(Convert.ToInt32(TB47.Text.ToString()), 7);
            if (TB48.Text.ToString() != "") puzzle.grid.ElementAt(4).SetValue(Convert.ToInt32(TB48.Text.ToString()), 8);

            if (TB50.Text.ToString() != "") puzzle.grid.ElementAt(5).SetValue(Convert.ToInt32(TB50.Text.ToString()), 0);
            if (TB51.Text.ToString() != "") puzzle.grid.ElementAt(5).SetValue(Convert.ToInt32(TB51.Text.ToString()), 1);
            if (TB52.Text.ToString() != "") puzzle.grid.ElementAt(5).SetValue(Convert.ToInt32(TB52.Text.ToString()), 2);
            if (TB53.Text.ToString() != "") puzzle.grid.ElementAt(5).SetValue(Convert.ToInt32(TB53.Text.ToString()), 3);
            if (TB54.Text.ToString() != "") puzzle.grid.ElementAt(5).SetValue(Convert.ToInt32(TB54.Text.ToString()), 4);
            if (TB55.Text.ToString() != "") puzzle.grid.ElementAt(5).SetValue(Convert.ToInt32(TB55.Text.ToString()), 5);
            if (TB56.Text.ToString() != "") puzzle.grid.ElementAt(5).SetValue(Convert.ToInt32(TB56.Text.ToString()), 6);
            if (TB57.Text.ToString() != "") puzzle.grid.ElementAt(5).SetValue(Convert.ToInt32(TB57.Text.ToString()), 7);
            if (TB58.Text.ToString() != "") puzzle.grid.ElementAt(5).SetValue(Convert.ToInt32(TB58.Text.ToString()), 8);

            if (TB60.Text.ToString() != "") puzzle.grid.ElementAt(6).SetValue(Convert.ToInt32(TB60.Text.ToString()), 0);
            if (TB61.Text.ToString() != "") puzzle.grid.ElementAt(6).SetValue(Convert.ToInt32(TB61.Text.ToString()), 1);
            if (TB62.Text.ToString() != "") puzzle.grid.ElementAt(6).SetValue(Convert.ToInt32(TB62.Text.ToString()), 2);
            if (TB63.Text.ToString() != "") puzzle.grid.ElementAt(6).SetValue(Convert.ToInt32(TB63.Text.ToString()), 3);
            if (TB64.Text.ToString() != "") puzzle.grid.ElementAt(6).SetValue(Convert.ToInt32(TB64.Text.ToString()), 4);
            if (TB65.Text.ToString() != "") puzzle.grid.ElementAt(6).SetValue(Convert.ToInt32(TB65.Text.ToString()), 5);
            if (TB66.Text.ToString() != "") puzzle.grid.ElementAt(6).SetValue(Convert.ToInt32(TB66.Text.ToString()), 6);
            if (TB67.Text.ToString() != "") puzzle.grid.ElementAt(6).SetValue(Convert.ToInt32(TB67.Text.ToString()), 7);
            if (TB68.Text.ToString() != "") puzzle.grid.ElementAt(6).SetValue(Convert.ToInt32(TB68.Text.ToString()), 8);

            if (TB70.Text.ToString() != "") puzzle.grid.ElementAt(7).SetValue(Convert.ToInt32(TB70.Text.ToString()), 0);
            if (TB71.Text.ToString() != "") puzzle.grid.ElementAt(7).SetValue(Convert.ToInt32(TB71.Text.ToString()), 1);
            if (TB72.Text.ToString() != "") puzzle.grid.ElementAt(7).SetValue(Convert.ToInt32(TB72.Text.ToString()), 2);
            if (TB73.Text.ToString() != "") puzzle.grid.ElementAt(7).SetValue(Convert.ToInt32(TB73.Text.ToString()), 3);
            if (TB74.Text.ToString() != "") puzzle.grid.ElementAt(7).SetValue(Convert.ToInt32(TB74.Text.ToString()), 4);
            if (TB75.Text.ToString() != "") puzzle.grid.ElementAt(7).SetValue(Convert.ToInt32(TB75.Text.ToString()), 5);
            if (TB76.Text.ToString() != "") puzzle.grid.ElementAt(7).SetValue(Convert.ToInt32(TB76.Text.ToString()), 6);
            if (TB77.Text.ToString() != "") puzzle.grid.ElementAt(7).SetValue(Convert.ToInt32(TB77.Text.ToString()), 7);
            if (TB78.Text.ToString() != "") puzzle.grid.ElementAt(7).SetValue(Convert.ToInt32(TB78.Text.ToString()), 8);

            if (TB80.Text.ToString() != "") puzzle.grid.ElementAt(8).SetValue(Convert.ToInt32(TB80.Text.ToString()), 0);
            if (TB81.Text.ToString() != "") puzzle.grid.ElementAt(8).SetValue(Convert.ToInt32(TB81.Text.ToString()), 1);
            if (TB82.Text.ToString() != "") puzzle.grid.ElementAt(8).SetValue(Convert.ToInt32(TB82.Text.ToString()), 2);
            if (TB83.Text.ToString() != "") puzzle.grid.ElementAt(8).SetValue(Convert.ToInt32(TB83.Text.ToString()), 3);
            if (TB84.Text.ToString() != "") puzzle.grid.ElementAt(8).SetValue(Convert.ToInt32(TB84.Text.ToString()), 4);
            if (TB85.Text.ToString() != "") puzzle.grid.ElementAt(8).SetValue(Convert.ToInt32(TB85.Text.ToString()), 5);
            if (TB86.Text.ToString() != "") puzzle.grid.ElementAt(8).SetValue(Convert.ToInt32(TB86.Text.ToString()), 6);
            if (TB87.Text.ToString() != "") puzzle.grid.ElementAt(8).SetValue(Convert.ToInt32(TB87.Text.ToString()), 7);
            if (TB88.Text.ToString() != "") puzzle.grid.ElementAt(8).SetValue(Convert.ToInt32(TB88.Text.ToString()), 8);
                         
            Display();
        }


        private void SolveBtn_Click(object sender, EventArgs e)
        {
            DateTime t0 = DateTime.Now;
            inference.Solve(puzzle);
            DateTime t1 = DateTime.Now;
            TimeSpan elapsedTime = t1 - t0;
            t = elapsedTime.ToString();
            Display();
        }

        private void SaveBtn_Click(object sender, EventArgs e)
        {

        }
    }
}
